#include <mega8.h>
#include <delay.h>
#include <alcd.h>
#include <string.h>
unsigned char y=0, u_data, ktra=0, buf[32];
/***Chuong trinh gui du lieu qua TX***/
void send1(unsigned char udata){//Ham gui 1 ky tu ASCII
    while(!(UCSRA & (1<<UDRE)));//Kiem tra co UDRE
    UDR=udata;//Send 1 byte
}
void send(unsigned char *u){//Ham gui mot chuoi ky tu
    unsigned char n,i;
    n=strlen(u); //Dem so ky tu
    for(i=0;i<n;i++) send1(u[i]);//Gui het chuoi
}
void xoa_buf(){//Ham xoa bo dem
     unsigned char u;
     for(u=0;u<32;u++) buf[u]=0;
}
/***Ham ngat xu ly nhan du lieu qua RX***/
interrupt [USART_RXC] void rx_isr(){
    u_data=UDR; //Lay du lieu ASCII
    if((u_data==0x57 || u_data==0x77) && ktra==0){//Phim W hoac phim w
        lcd_clear();//Xoa LCD
        lcd_gotoxy(0,0); 
        xoa_buf(); //Xoa buffer
        lcd_puts("Dang nhap..."); 
        send("\rMoi nhap noi dung hien thi:\rToi da 32 ky tu - Enter de hien thi\rText> "); 
        ktra=1;
    }else if(u_data==13 && ktra==1){//Phim Enter
        send("\rSend to LCD...");
        lcd_clear();
        lcd_gotoxy(0,0); 
        lcd_puts(buf);//Gui len LCD
        send("\rNhan phim W de nhap moi...\r");
        ktra=0; y=0;
    }else if(u_data==8 && ktra==1){ //Nut xoa BackSpace 
        if(y>0)y--;  else send("\rText> ");
        buf[y]=0;
    }else if(ktra==1){ 
        //Kiem tra ky tu nhap va luu vao buffer
        if(u_data>31 && y<31) buf[y++]=u_data; 
    }//end if
}
/*****************Chuong trinh chinh************/
void main(){
    UCSRB=0x98;//Ngat RX, cho phep RX va TX
    UCSRC=0x86;//8bit uart, 1bit stop, no parity
    UBRRL=71;//baud 9600bps
    lcd_init(16); //LCD16x2 init
    lcd_puts("TEST USART AVR!");//Gui chuoi len LCD
    delay_ms(500);//Tre 0.5s
    lcd_gotoxy(0,1);//Dong 2
    lcd_puts("SangTaoClub.Net");
    delay_ms(1000);
    send("Nhan phim W de nhap noi dung! \r"); 
    #asm("sei")  //Ngat cuc bo
    while(1); //Khong lam gi ca 
}//THE END